package Helper;

import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.util.stream.IntStream;
import java.util.stream.LongStream;

import static java.util.stream.IntStream.rangeClosed;

public class HelperClass {

  public static boolean isPrime(long n) {
    if (n < 2) {
      return false;
    }
    if (n == 2 || n == 3) {
      return true;
    }
    if (n % 2 == 0 || n % 3 == 0) {
      return false;
    }
    for (long i = 6; i <= Math.sqrt((double) n) + 1; i += 6) {
      if (n % (i - 1) == 0 || n % (i + 1) == 0) {
        return false;
      }
    }
    return true;
  }

  public static <T> boolean isPalindrome(T number) {
    String numberAsString = String.valueOf(number);
    return rangeClosed(0, numberAsString.length() / 2).allMatch(i -> numberAsString.charAt(i) == numberAsString.charAt(numberAsString.length() - 1 - i));
  }

  public static HashMap<Long, Integer> getPrimeFactors(long number) {
    return getPrimeFactorsRecursion(new HashMap<>(), number);
  }

  private static HashMap<Long, Integer> getPrimeFactorsRecursion(HashMap<Long, Integer> map, long number) {
    if (isPrime(number)) {
      map.put(number, map.containsKey(number) ? map.get(number) + 1 : 1);
      return map;
    } else {
      for (long i = 2; i < number; i++) {
        if (isPrime(i) && number % i == 0) {
          map.put(i, map.containsKey(i) ? map.get(i) + 1 : 1);
          return getPrimeFactorsRecursion(map, number / i);
        }
      }
    }
    return null;
  }

  public static long numberOfDivisors(long n) {
    HashMap<Long, Integer> primeFactors = getPrimeFactors(n);
    return primeFactors.keySet().stream().mapToLong(k -> primeFactors.get(k) + 1).reduce(1, Math::multiplyExact);
  }

  /*
   * Return the number of terms generated by the Collatz iterative sequence.
   */
  public static long getCollatzCount(long counter, long number) {
    if (number == 1) {
      counter++;
      return counter;
    } else {
      counter++;
      if (number % 2 == 0) {
        return getCollatzCount(counter, number / 2);
      } else {
        return getCollatzCount(counter, 3 * number + 1);
      }
    }
  }

  public static <T> int sumMapValues(HashMap<T, Integer> map) {
    return map.keySet().stream().mapToInt(map::get).sum();
  }

  public static <T> long sumOfDigits(T number) {
    return String.valueOf(number).chars().mapToLong(Character::getNumericValue).sum();
  }

  public static BigInteger factorial(BigInteger n) {
    BigInteger result = BigInteger.ONE;
    while (!n.equals(BigInteger.ZERO)) {
      result = result.multiply(n);
      n = n.subtract(BigInteger.ONE);
    }
    return result;
  }

  public static int factorial(int n) {
    int result = 1;
    while (n != 0) {
      result = result * n;
      n = n - 1;
    }
    return result;
  }

  public static int sumOfFactorial(int n) {
    String string = String.valueOf(n);
    int sum = 0;
    for (Character digit : string.toCharArray()) {
      sum += factorial(Character.getNumericValue(digit));
    }
    return sum;
  }

  public static long sumOfDivisors(long n) {
    if (n == 1) {
      return n;
    }
    HashMap<Long, Integer> primeFactors = getPrimeFactors(n);
    final long[] sum = {1};
    primeFactors.keySet().forEach(k -> {
      long x = 0;
      for (int i = 0; i <= primeFactors.get(k); i++) {
        x += Math.pow(k, i);
      }
      sum[0] *= x;
    });
    return sum[0] - n;
  }

  public static long alphabeticalValue(String string) {
    return string.chars().map(i -> i - 64).sum();
  }

  /*
   * Return the number of primes produced by the formula: n^2 + an + b
   * for consecutive integer values of n, starting with n = 0.
   */
  public static long primeCount(int a, int b) {
    int n = 0;
    int result = n * n + a * n + b;
    while (isPrime(result)) {
      n++;
      result = n * n + a * n + b;
    }
    return n;
  }

  /*
   * Check if the number n equals the sum of the kth power of its digits.
   */
  public static boolean nEqualskDigitSum(long n, long k) {
    return String.valueOf(n).chars().
        mapToDouble(c -> Math.pow(Character.getNumericValue(c), k)).
        sum() == n;
  }

  /*
   * Checks if an n-digit number makes use of all the digits from 1 to n.
   */
  public static <T> boolean isPanDigital(T number) {
    String string = String.valueOf(number);
    return IntStream.rangeClosed(1, string.length())
        .mapToObj(i -> Character.forDigit(i, 10))
        .noneMatch(c -> string.indexOf(c) == -1 || string.indexOf(c) != string.lastIndexOf(c));
  }

  /*
   * Returns the number of digits (excluding 0) appearing in both provided numbers exactly once.
   */
  public static long commonDigits(int n, int k) {
    return String.valueOf(n).chars().filter(c -> c != '0'
        && String.valueOf(n).indexOf(c) == String.valueOf(n).lastIndexOf(c)
        && String.valueOf(k).indexOf(c) != -1
        && String.valueOf(k).indexOf(c) == String.valueOf(k).lastIndexOf(c)).count();
  }

  public static double removeCommonDigit(int n, int k) {
    String number1 = String.valueOf(n);
    String number2 = String.valueOf(k);
    for (Character digit : number1.toCharArray()) {
      for (Character digit2 : number2.toCharArray()) {
        if (digit == digit2) {
          number1 = number1.replace(digit.toString(), "");
          number2 = number2.replace(digit2.toString(), "");
        }
      }
    }
    return Double.valueOf(number1) / Double.valueOf(number2);
  }

  public static long greatestCommonDivisor(long[] numbers) {
    long dividend = numbers[0];
    long divisor = numbers[1];
    long remainder = dividend % divisor;
    while (remainder != 0) {
      dividend = divisor;
      divisor = remainder;
      remainder = dividend % divisor;
    }
    return divisor;
  }

  public static long leastCommonMultiple(long[] numbers) {
    Map<Long, Integer> allPrimeFactors = new HashMap<>();
    for (long i : numbers) {
      HashMap<Long, Integer> primeFactors = getPrimeFactors(i);
      for (Long factor : primeFactors.keySet()) {
        if (!allPrimeFactors.containsKey(factor) || allPrimeFactors.get(factor) < primeFactors.get(factor)) {
          allPrimeFactors.put(factor, primeFactors.get(factor));
        }
      }
    }
    return allPrimeFactors.keySet().stream().mapToInt(k -> ((int) Math.pow(k, allPrimeFactors.get(k)))).reduce(1,
        Math::multiplyExact);
  }

  /*A number is a circular prime, if all rotations of its digits are themselves prime.*/
  public static boolean isCircularPrime(long n) {
    char[] array = String.valueOf(n).toCharArray();
    for (char c : array) {
      char[] newArray = new char[array.length];
      for (int j = 0; j < array.length; j++) {
        newArray[(j + 1) % array.length] = array[j];
      }
      if (!isPrime(Long.parseLong(new String(newArray)))) {
        return false;
      }
      array = newArray;
    }
    return true;
  }

  public static BigInteger toBinary(long number) {
    StringBuilder stringBuilder = new StringBuilder("");
    while (number / 2 >= 0 && number != 0) {
      stringBuilder.append(number % 2 == 0 ? '0' : '1');
      number /= 2;
    }
    return new BigInteger(stringBuilder.reverse().toString());
  }

  public static boolean isTruncatablePrime(long n) {
    String asString = String.valueOf(n);
    String asString2 = String.valueOf(n);
    while (asString.length() > 0) {
      if (!isPrime(Long.valueOf(asString)) || !isPrime(Long.valueOf(asString2))) {
        return false;
      }
      asString = asString.substring(1);
      asString2 = asString2.substring(0, asString2.length() - 1);
    }
    return true;
  }

  /*
   * Return the nth digit of the number created by concatenating the positive integers.
   */
  public static int getNthDigit(int n) {
    long numberOfDigits = 0;
    int i = 1;
    while (numberOfDigits + 9 * Math.pow(10, i - 1) * i < n) {
      numberOfDigits += 9 * Math.pow(10, i - 1) * i;
      i++;
    }
    long range = n - numberOfDigits;
    String string = String.valueOf((int) Math.pow(10, i - 1) + range / i);
    int remainder = (int) range % i;
    if (remainder > 0) {
      return Character.getNumericValue(string.charAt(remainder - 1));
    } else {
      string = String.valueOf(Integer.valueOf(string) - 1);
      return Character.getNumericValue(string.charAt(string.length() - 1));
    }
  }

  public static boolean isTriangleNo(long n) {
    return ((Math.sqrt(8 * n + 1) - 1) / 2.0) % 1.0 == 0;
  }

  public static boolean isSquare(long n) {
    return Math.sqrt(n) % 1.0 == 0;
  }

  public static boolean isPentagonalNo(long n) {
    return ((Math.sqrt(24 * n + 1) + 1) / 6.0) % 1.0 == 0;
  }

  public static boolean isHexagonalNo(long n) {
    return ((Math.sqrt(8 * n + 1) + 1) / 4.0) % 1.0 == 0;
  }

  public static boolean isHeptagonalNo(long n) {
    return ((Math.sqrt(40 * n + 9) + 3) / 10.0) % 1.0 == 0;
  }

  public static boolean isOctogonalNo(long n) {
    return ((Math.sqrt(3 * n + 1) + 1) / 3.0) % 1.0 == 0;
  }

  public static List<Integer> polygonalTypes(long n) {
    List<Integer> list = new ArrayList<>();
    if (isTriangleNo(n))
      list.add(3);
    if (isSquare(n))
      list.add(4);
    if (isPentagonalNo(n))
      list.add(5);
    if (isHexagonalNo(n))
      list.add(6);
    if (isHeptagonalNo(n))
      list.add(7);
    if (isOctogonalNo(n))
      list.add(8);
    return list;
  }

  public static <T> boolean substringsProducePrime(T input) {
    int[] primes = {2, 3, 5, 7, 11, 13, 17};
    String string = String.valueOf(input);
    return IntStream.range(1, 8)
        .allMatch(i -> Integer.valueOf(string.substring(i, i + 3)) % primes[i - 1] == 0);
  }

  public static <T> boolean arePermutations(T n, T k) {
    char[] nArray = String.valueOf(n).toCharArray();
    char[] kArray = String.valueOf(k).toCharArray();
    Arrays.sort(nArray);
    Arrays.sort(kArray);
    return Arrays.equals(nArray, kArray);
  }

  public static long nCr(long n, long r) {
    BigInteger N = BigInteger.valueOf(n);
    BigInteger R = BigInteger.valueOf(r);
    BigInteger divisor = factorial(R).multiply(factorial(N.subtract(R)));
    return factorial(N).divide(divisor).longValue();
  }

  /*
   * Generate a List of Lists containing every variation of the number n,
   * where 3 of its digits have been replaced by the same single digit.
   */
  public static List<List<String>> replaceDigits(int n) {
    String string = String.valueOf(n);
    List<String> list = new ArrayList<>();
    for (int i = 0; i < 10; i++) {
      for (int j = 0; j < string.length(); j++) {
        for (int k = j + 1; k < string.length(); k++) {
          for (int l = k + 1; l < string.length(); l++) {
            char[] tempArray = string.toCharArray();
            tempArray[j] = Character.forDigit(i, 10);
            tempArray[k] = Character.forDigit(i, 10);
            tempArray[l] = Character.forDigit(i, 10);
            list.add(new String(tempArray));
          }
        }
      }
    }
    long nCr = nCr(string.length(), 3);
    return LongStream.range(0, nCr)
        .mapToObj(i -> LongStream.iterate(0, j -> j + nCr).limit(10)
            .mapToObj(j -> list.get((int) (j + i))).filter(s -> !s.startsWith("0"))
            .collect(Collectors.toList()))
        .collect(Collectors.toList());
  }

  public static BigInteger reverseNumber(BigInteger n) {
    StringBuilder builder = new StringBuilder(String.valueOf(n)).reverse();
    return new BigInteger(builder.toString());
  }

  /*
   * Returns all possible combinations of r elements taken from a list of size n.
   * The elements are represented by their indices.
   */
  public static List<int[]> getNCRCombinations(int n, int r) {
    List<int[]> list = new ArrayList<>();
    list.add(IntStream.range(0, r).toArray());
    int counter = 0;
    long limit = nCr(n, r) - 1;
    while (counter < limit) {
      int[] tmp = Arrays.copyOf(list.get(counter), r);
      for (int i = r - 1; i >= 0; i--) {
        if (tmp[i] < n - r + i) {
          tmp[i]++;
          for (int j = i + 1; j < r; j++) {
            tmp[j] = tmp[j - 1] + 1;
          }
          list.add(tmp);
          counter++;
          break;
        }
      }
    }
    return list;
  }

  /*
   * Returns true if the concatenation of the provided numbers (both ways) produces a prime.
   * (As per the requirements of problem 60.)
   */
  public static boolean primePairs(int i, int j) {
    String concat1 = String.valueOf(i) + String.valueOf(j);
    String concat2 = String.valueOf(j) + String.valueOf(i);
    return isPrime(Long.valueOf(concat1)) && isPrime(Long.valueOf(concat2));
  }

  /*
   * Returns the repeating period in the continued fractions representation
   * of an irrational square root.
   */
  public static List<Integer> contdFractionsPeriod(int constant, int number, int initial, List<Integer> list, int nominator) {
    int squareRoot = (int) Math.sqrt(number);
    int square = (int) Math.pow(initial, 2);
    int denominator = (number - square) / nominator;
    int whole = (squareRoot + initial) / denominator;
    list.add(whole);
    if (whole != 2 * constant) {
      return contdFractionsPeriod(constant, number, whole * denominator - initial, list, denominator);
    }
    return list;
  }

  /*
   * Returns the continued fractions representation of an irrational square root after the provided target number of iterations.
   */
  public static List<Integer> contdFractions(int number, int initial, List<Integer> list, int nominator, int counter, int target) {
    int squareRoot = (int) Math.sqrt(number);
    int square = (int) Math.pow(initial, 2);
    int denominator = (number - square) / nominator;
    int whole = (squareRoot + initial) / denominator;
    list.add(whole);
    if (counter == target) {
      return list;
    } else {
      return contdFractions(number, whole * denominator - initial, list, denominator, counter + 1, target);
    }
  }

  /*
   * Rotates the elements of the given list to the right by the specified number.
   * (So if the input number is 1, the last element of the list will become the first one.)
   */
  private static List<Integer> shiftList(List<Integer> oldList, int number) {
    Integer[] oldArray = new Integer[oldList.size()];
    oldArray = oldList.toArray(oldArray);
    Integer[] newArray = new Integer[oldArray.length];
    for (int i = 0; i < oldArray.length; i++) {
      newArray[(i + number) % oldArray.length] = oldArray[i];
    }
    return new ArrayList<>(Arrays.asList(newArray));
  }

  /*
   * Returns the convergent for a regular continued fraction for a given number of expansions
   * based on the repeating period.
   * (The convergent is an approximation for the value of an irrational square root
   * in the form of a simple fraction. Its precision depends on the number of expansions.)
   */
  public static BigInteger[] getConvergent(List<Integer> periodList, int expCount, int number) {
    periodList = shiftList(periodList, 1);
    BigInteger denominator = BigInteger.valueOf(periodList.get(expCount % periodList.size()));
    BigInteger numerator = BigInteger.ONE;
    while (expCount > 1) {
      expCount--;
      BigInteger whole = BigInteger.valueOf(periodList.get(expCount % periodList.size()));
      BigInteger temp = whole.multiply(denominator).add(numerator);
      numerator = denominator;
      denominator = temp;
    }
    BigInteger whole = BigInteger.valueOf((long) Math.sqrt(number));
    BigInteger finalNumerator = whole.multiply(denominator).add(numerator);
    return new BigInteger[] {finalNumerator, denominator};
  }

  /*
  Returns the number of positive integers <= n that are relatively prime n.
   */
  public static double getTotient(long n) {
    final double[] counter = {n};
    getPrimeFactors(n).keySet().forEach(p -> counter[0] *= (1.0 - 1.0 / (double) p));
    return counter[0];
  }
}
